//+--------------------------------------------------+
//|PipGrabber                                        |
//+--------------------------------------------------+

#include <stdlib.mqh>
#include <stderror.mqh>

#define  NL    "\n"
extern int magic = 1012;
extern int Vlim=50;

// Regular variables
extern int MaxOrders=9;
extern double  LotSize                 = 00.2;
extern double  LotIncrement            = 2;
//extern bool    Multiplier            = true;
extern int     Multiplier              = 1;
extern int     ProfitTarget            = 20;
//extern bool    OpenOnTick            = false;
extern int     OpenOnTick              = 70;
extern int     Spacing                 = 10;
extern int     TrendSpacing            = 10;
extern double  CounterTrendMultiplier  = 2;
extern double  CloseDelay              = 10;
//extern int     TrendTimeFrame          = PERIOD_M30;
//extern int     TrendPeriods            = 7;
extern bool    CeaseTrading            = false;
extern bool    RightSideLabel          = true;
extern double deltad=5.0000,stolevel=4.0000;
extern double hmaperiod=50,qqelev=0.005,juicelevel=0;
extern int MaMetod  = 2;
extern int MaPeriod = 6;
extern int MaMetod2  = 3;
extern int MaPeriod2 = 2;
// Internal settings
int            Step           = 1;
int            Error          = 0;
int            Order          = 0;
int            Slippage       = 3;
int            Reference      = 9990;
string         TradeComment   = "PipMaker v5 Neo";
datetime       BarTime        = 0;
static bool    TradeAllowed   = true;
double         TickPrice      = 0;
int cnt;
int            MaxBuys        = 0;
int            MaxSells       = 0;
double Lots;
bool           Auditing       = true;
string         Filename       = "PipMaker.txt";
double buysell=0,Whist;
int etb,ets,ttb,tts;
int day;
int orders,bo,so;
   double         Trend,diff,diff1,diff2,PrevTrend, teudiff;
   int            SellOrders, BuyOrders,buyonly,sellonly;
  double   ZigZagUp,ZigZagDown;
    double d,db4, dynrsislow, dynrsislowb4,lag,lagb4,lagdn,lagdnb4,smiup,smiupb4,cop,copb4;
double smidn,smidnb4,juicedelta,juicedeltab4,juicedeltab4b4,hma,hmab4,lotpop,qqe,qqeb4,sto,stob4,cci;
extern int per=10; //period for dynamic rsi
 int bb=20,up1,up5,up15,up30,up60,dn1,dn5,dn15,dn30,dn60,up601,dn601,up360,dn360,upd1,dnd1,dd;
 int upsignal,emergencyup,dnsignal,emergencydn;
  double hasopen1;
    double haClose1;
    double hasopen5 ;
    double haClose5 ;
    double hasopen15;
    double haClose15;
    double hasopen30 ;
    double haClose30;
    double hasopen60;
    double haClose60;
    double haClose60b4;
    double stom1;
   double stom1b4;
   //--- arrays for various things
int     TF[]              = {1,5,15,30,60,60};
//--- to adjust periods for each timeframe adjust here, save and compile
int     eCCI[]            = {14,14,6,6,6,6};
int     tCCI[]            = {50,34,14,14,14,14};
//---
    int init()
{
}

int deinit()
{

}


void CloseBuysInProfit()
{
   double SellProfit,BuyProfit, LastBuyTime;

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_BUY)
         {
            BuyProfit = OrderProfit() + OrderSwap() + OrderCommission();
            if (OrderOpenTime() > LastBuyTime) LastBuyTime = OrderOpenTime();
            if ((IsTesting() || TimeCurrent() - LastBuyTime >= CloseDelay) ) OrderClose(OrderTicket(), OrderLots(), Bid, 5, Green);

            Error = GetLastError();
            if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (A" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));
         }
      }
   }
   return;
}


void CloseSellsInProfit()
{
   double BuyProfit,SellProfit, LastSellTime;

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_SELL)
         {
            SellProfit = OrderProfit() + OrderSwap() + OrderCommission();
            if (OrderOpenTime() > LastSellTime) LastSellTime = OrderOpenTime();
            if ((IsTesting() || TimeCurrent() - LastSellTime >= CloseDelay) ) OrderClose(OrderTicket(), OrderLots(), Ask, 5, Red);

            Error = GetLastError();
            if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (B" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));
         }
      }
   }

   return;
}


void PlaceBuyOrder()
{
   if ( OrdersTotal()>MaxOrders) return(0);

   double BuyOrders, Lots;
   double LowestBuy = 1000, HighestBuy;
   if (BarTime == Time[0]) return(0);
   
     
      TickPrice = 0;
      TradeAllowed = true;
 

   RefreshRates();
   if (TradeAllowed)
   {
   BuyOrders=0;
   
   for (Order = OrdersTotal() ; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_BUY)
         {
            orders++;
            BuyOrders++;
         }
      }
   }
  
      //if (Ask >= HighestBuy + (TrendSpacing * Point))
      {
//         if (Multiplier)
         if (Multiplier == 1)
         {
        // LotIncrement= MathCeil((hma-hmab4)*10000);

            Lots = NormalizeDouble(LotSize * MathPow(LotIncrement, BuyOrders), 2);
         }
         else
            Lots = NormalizeDouble(LotSize + (LotIncrement * BuyOrders), 2);
      }

     

      if (Lots == 0)
      {
         if (Multiplier == 1)
            Lots = NormalizeDouble(LotSize, 2);
         else
            Lots = NormalizeDouble(LotSize, 2);
      }
             
           
                 
             
      {   
                

      OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, 0, TradeComment, Reference, Green);
                  BarTime=Time[0];upsignal=0;emergencyup=0;


      Error = GetLastError();
      if (Error != 0)
         Write("Error opening BUY order: " + ErrorDescription(Error) + " (C" + Error + ")  Ask:" + Ask + "  Slippage:" + Slippage);
      else
      {
         TickPrice = Close[0];
         TradeAllowed = false;
      }
   }
}}


void PlaceSellOrder()
{
   if ( OrdersTotal()>MaxOrders) return(0);

   double SellOrders, Lots;
   double HighestSell, LowestSell = 1000;

   if (BarTime ==Time[0]) return(0);
   {
     
      TickPrice = 0;
      TradeAllowed = true;
   }
   if (TradeAllowed)
{
   RefreshRates();
   SellOrders=0;
   for (Order = OrdersTotal(); Order >= 0; Order--)
   
   
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_SELL)
         {
           
            SellOrders++;
         }
      }
   }

  
   {
      //if (Bid <= LowestSell - (TrendSpacing * Point))
      
//         if (Multiplier)
       if (Multiplier == 1)
       {
          //  LotIncrement= MathCeil(MathAbs(hma-hmab4)*10000);
            Lots = NormalizeDouble(LotSize * MathPow(LotIncrement, SellOrders), 2);
        }
         else
            Lots = NormalizeDouble(LotSize + (LotIncrement * SellOrders), 2);
      }
      
     
      
      if (Lots == 0)
      {
//         if (Multiplier) 
         if (Multiplier == 1)
            Lots = NormalizeDouble(LotSize, 2);
         else
            Lots = NormalizeDouble(LotSize, 2);
            
      }
          
      
                   
  
              {   
          
                      
                  OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0, 0, TradeComment, Reference, Red);
                  BarTime=Time[0];dnsignal=0;emergencydn=0;
      Error = GetLastError();
      if (Error != 0)
         Write("Error opening SELL order: " + ErrorDescription(Error) + " (D" + Error + ")  Bid:" + Bid + "  Slippage:" + Slippage);
      else
      {
         TickPrice = Close[0];
         TradeAllowed = false;
      }
   }
}}


int start()
{
   double         MarginPercent;
   static double  LowMarginPercent = 10000000, LowEquity = 10000000;
   double         BuyPipTarget, SellPipTarget;
   double         BuyPips, SellPips, BuyLots, SellLots;
   double         LowestBuy = 999, HighestBuy = 0.0001, LowestSell = 999, HighestSell = 0.0001, HighPoint, MidPoint, LowPoint;
   double         Profit = 0, BuyProfit = 0, SellProfit = 0, PosBuyProfit = 0, PosSellProfit = 0;
   int            HighestBuyTicket, LowestBuyTicket, HighestSellTicket, LowestSellTicket;
   double         HighestBuyProfit, LowestBuyProfit, HighestSellProfit, LowestSellProfit;
   double         CurrentTime = (TimeHour(CurTime() + TimeMinute(CurTime())));
   bool           SELLme = false;
   bool           BUYme = false;
   double         Margin = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   string         Message;

   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference)
         {
            Profit = OrderProfit() + OrderSwap() + OrderCommission();
            
            if (OrderType() == OP_BUY)
            {
               if (OrderOpenPrice() >= HighestBuy)
               {
                  HighestBuy = OrderOpenPrice();
                  HighestBuyTicket = OrderTicket();
                  HighestBuyProfit = Profit;
               }

               if (OrderOpenPrice() <= LowestBuy)
               {
                  LowestBuy = OrderOpenPrice();
                  LowestBuyTicket = OrderTicket();
                  LowestBuyProfit = Profit;
               }

               //BuyOrders++;
               if (BuyOrders > MaxBuys) MaxBuys = BuyOrders;
               BuyLots += OrderLots();

               BuyProfit += Profit;
               if (Profit > 0) PosBuyProfit += Profit;
            }

            if (OrderType() == OP_SELL)
            {
               if (OrderOpenPrice() <= LowestSell)
               {
                  LowestSell = OrderOpenPrice();
                  LowestSellTicket = OrderTicket();
                  LowestSellProfit = Profit;
               }

               if (OrderOpenPrice() >= HighestSell)
               {
                  HighestSell = OrderOpenPrice();
                  HighestSellTicket = OrderTicket();
                  HighestSellProfit = Profit;
               }

               //SellOrders++;
              // if (SellOrders > MaxSells) MaxSells = SellOrders;
               SellLots += OrderLots();

               SellProfit += Profit;
               if (Profit > 0) PosSellProfit += Profit;
            }
         }
      }
   }

      BuyPipTarget = ProfitTarget;
      SellPipTarget = ProfitTarget;

   if (HighestBuy >= HighestSell)
      HighPoint = HighestBuy;
   else
      HighPoint = HighestSell;

   if (LowestBuy <= LowestSell)
      LowPoint = LowestBuy;
   else
      LowPoint = LowestSell;

   //MidPoint = (HighPoint + LowPoint) / 2;

//   if ((SellOrders > 1 && BuyOrders > 0) || (SellOrders > 0 && BuyOrders > 1)) MidPoint = (HighPoint + LowPoint) / 2;

   RefreshRates();

   if (Ask > MidPoint)
   {
      if (PosBuyProfit + LowestSellProfit >= ProfitTarget && LowestSell < LowestBuy)
      {
         OrderSelect(LowestSellTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing SELL order " + LowestSellTicket + ": " + ErrorDescription(Error) + " (E" + Error + ")");

         //OrderClose(OrderTicket(), OrderLots(), Ask, 5, Green);

         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (F" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

        // CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         LowestSell = 1000;
         LowestSellTicket = 0;
      }
      else if (PosSellProfit + LowestSellProfit >= ProfitTarget && LowestSell < LowestBuy)
      {
         OrderSelect(LowestSellTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing SELL order " + LowestSellTicket + ": " + ErrorDescription(Error) + " (G" + Error + ")");

        // OrderClose(OrderTicket(), OrderLots(), Ask, 5, Red);

         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (H" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

        // CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         LowestSellTicket = 0;
      }
      else if (PosBuyProfit + LowestBuyProfit >= ProfitTarget && LowestBuy < LowestSell)
      {
         OrderSelect(LowestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing BUY order " + LowestBuyTicket + ": " + ErrorDescription(Error) + " (I" + Error + ")");

         //OrderClose(OrderTicket(), OrderLots(), Bid, 5, Green);

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (J" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

       //  CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         LowestBuyTicket = 0;
      }
      else if (PosSellProfit + LowestBuyProfit >= ProfitTarget && LowestBuy < LowestSell)
      {
         OrderSelect(LowestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing BUY order " + LowestBuyTicket + ": " + ErrorDescription(Error) + " (K" + Error + ")");

        // OrderClose(OrderTicket(), OrderLots(), Bid, 5, Red);

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (L" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

        // CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         LowestBuy = 1000;
         LowestBuyTicket = 0;
      }
   }
   else if (Bid < MidPoint)
   {
      if (PosBuyProfit + HighestBuyProfit >= ProfitTarget && HighestBuy > HighestSell)
      {
         OrderSelect(HighestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing BUY order " + HighestBuyTicket + ": " + ErrorDescription(Error) + " (M" + Error + ")");

        // OrderClose(OrderTicket(), OrderLots(), Bid, 5, Green);

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (N" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));
        // CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         HighestBuyTicket = 0;
      }
      else if (PosSellProfit + HighestBuyProfit >= ProfitTarget && HighestBuy > HighestSell)
      {
         OrderSelect(HighestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing BUY order " + HighestBuyTicket + ": " + ErrorDescription(Error) + " (O" + Error + ")");

        // OrderClose(OrderTicket(), OrderLots(), Bid, 5, Red);

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (P" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

        // CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         HighestBuy = 0;
         HighestBuyTicket = 0;
      }
      else if (PosBuyProfit + HighestSellProfit >= ProfitTarget && HighestSell > HighestBuy)
      {
         OrderSelect(HighestSellTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing SELL order " + HighestSellTicket + ": " + ErrorDescription(Error) + " (Q" + Error + ")");

        // OrderClose(OrderTicket(), OrderLots(), Ask, 5, Green);

         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (R" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

        // CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         HighestSell = 0;
         HighestSellTicket = 0;
      }
      else if (PosSellProfit + HighestSellProfit >= ProfitTarget && HighestSell > HighestBuy)
      {
         OrderSelect(HighestSellTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing SELL order " + HighestSellTicket + ": " + ErrorDescription(Error) + " (S" + Error + ")");

        // OrderClose(OrderTicket(), OrderLots(), Ask, 5, Red);

         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (T" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

        // CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         HighestSellTicket = 0;
      }
   }

   RefreshRates();
   
   //double jma=iCustom(NULL,0,"jaimo-jma",1,0);
  // double jmab4=iCustom(NULL,0,"jaimo-jma",1,1);
   double jmadiff=9;//jma-jmab4;
   double  testopma  = iCustom(NULL,0,"adaptive rsi", per,0,1);
   double  testopmab4  = iCustom(NULL,0,"adaptive rsi", per,0,2);
  
   teudiff=testopma-testopmab4;
  // double tedndiff=testopdn-testopdnb4;
   etb=0;ets=0;ttb=0;tts=0;
  
 	for(int x=0;x<6;x++)
    {
    	if (( iCustom(NULL,TF[x],"adaptive rsi",per, 0,1))>( iCustom(NULL,TF[x],"adaptive rsi", per, 0,2))) 
		{                                           
        	etb++;
      	}
       	if (( iCustom(NULL,TF[x],"adaptive rsi", per, 0,1))<( iCustom(NULL,TF[x],"adaptive rsi", per, 0,2))) 
       	{                                           
        	ets++;
       	}
	}
    
	if(buysell<0 && buysell<dd )dd=buysell;
            
           
        
           
    
Comment (up5+up15+up30+up60+up601+up360,"   dn ",dn5+dn15+dn30+dn60+dn601+dn360,  " Biggest drawdown ",dd," bo=",bo," so=",so,
"\nentry buy ",etb,

"\nentry SEll ",ets,

"\nJaidiff ",teudiff);




 
 CloseAllOrders();
  
    
      {
         BUYme = false;
               
          
            if  (teudiff>0.0020 && etb==6) upsignal=1;//&& etb+ttb==10&& ets+tts==0 )|| teudiff>20) upsignal=1;
           
                        if (bo>0 && etb==6 ) emergencyup=1;
                            if (upsignal==1 || emergencyup==1)
     {
         if (OpenOnTick == 1 && TickPrice > 0 && Close[0] < TickPrice) TradeAllowed = true;
      
      if (CeaseTrading && BuyOrders == 0) BUYme = false;
              
                      {
                     
                     
           PlaceBuyOrder();
           BUYme=true;
   }}}

   
        

      {
         SELLme = false;
//         
         if (OpenOnTick == 1 && TickPrice > 0 && Close[0] > TickPrice) TradeAllowed = true;
     
      if (CeaseTrading && SellOrders == 0) SELLme = false;
        
           if (teudiff<-0.0020 && ets==6)dnsignal=1;//&& ets+tts==10 && etb+ttb==0)|| teudiff<-20) dnsignal=1;
                 if ( ets==6 && so>0) emergencydn=1;
                
                 if(dnsignal==1||  emergencydn==1)
  
     {
              
                      {
             
                SELLme=true;
                 PlaceSellOrder();
      
   }}
}
 

   Message = "                    PipMaker v5 Neo" + NL +
             "                            ProfitTarget           " + DoubleToStr(BuyPipTarget, 2) + NL +
             "                            Buys                    " + BuyOrders + "  Highest: " + MaxBuys + NL +
             "                            BuyLots                " + DoubleToStr(BuyLots, 2) + NL +
             "                            BuyProfit              " + DoubleToStr(BuyProfit, 2) + NL +
             "                            Highest Buy           " + DoubleToStr(HighestBuy, Digits) + " #" + DoubleToStr(HighestBuyTicket, 0) + "  Profit: " + DoubleToStr(HighestBuyProfit, 2) + NL +
             "                            Highest Sell           " + DoubleToStr(HighestSell, Digits) + " #" + DoubleToStr(HighestSellTicket, 0) + "  Profit: " + DoubleToStr(HighestSellProfit, 2) + NL + NL +
             "                            ProfitTarget           " + DoubleToStr(SellPipTarget, 2) + NL +
             "                            Sells                     " + SellOrders + "  Highest: " + MaxSells + NL +
             "                            SellLots                 " + DoubleToStr(SellLots, 2) + NL +
             "                            SellProfit               " + DoubleToStr(SellProfit, 2) + NL +
             "                            Lowest Buy            " + DoubleToStr(LowestBuy, Digits) + " #" + DoubleToStr(LowestBuyTicket, 0) + "  Profit: " + DoubleToStr(LowestBuyProfit, 2) + NL +
             "                            Lowest Sell            " + DoubleToStr(LowestSell, Digits) + " #" + DoubleToStr(LowestSellTicket, 0) + "  Profit: " + DoubleToStr(LowestSellProfit, 2) + NL + NL +
             "                            Balance                " + DoubleToStr(AccountBalance(), 2) + NL +
             "                            Equity                  " + DoubleToStr(AccountEquity(), 2) + "  Lowest: " + DoubleToStr(LowEquity, 2) + NL + NL +
             "                            Margin                  " + DoubleToStr(AccountMargin(), 2) + NL +
             "                            MarginPercent        " + DoubleToStr(MarginPercent, 2) + NL +
             "                            LowMarginPercent  " + DoubleToStr(LowMarginPercent, 2) + NL +
             "                            Current Time is      " +  TimeToStr(TimeCurrent(), TIME_SECONDS);
                                                                         
   buysell=BuyProfit+SellProfit;
   if  (BuyProfit+SellProfit>=ProfitTarget )
   {
                CloseSellsInProfit();
                CloseBuysInProfit();
                SellOrders=0;
                BuyOrders=0;
                Lots=0;
   }             
   if (RightSideLabel) 
      {
         string MarPercent = DoubleToStr(MarginPercent, 0);
         string LowMarPercent = DoubleToStr(LowMarginPercent, 0);
         string displaybuysell = DoubleToStr(buysell, 0);


         string AcctBalance = DoubleToStr(AccountBalance(), 0);
         ObjectDelete("MarginPercent");

         if (ObjectFind("MarginPercent") != 0)
            {
               ObjectCreate("MarginPercent", OBJ_TEXT, 0, Time[0], Close[0]);
               ObjectSetText("MarginPercent",  Ask + "  " + Bid + "  $" + buysell, 12, "Arial", White);
            }
         else
            {
               ObjectMove("MarginPercent", 0, Time[0], Close[0]);
            }
      }

   if (ObjectFind("MidPoint") != 0)
   {
      ObjectCreate("MidPoint", OBJ_HLINE, 0, Time[0], MidPoint);
      ObjectSet("MidPoint", OBJPROP_COLOR, Blue);
      ObjectSet("MidPoint", OBJPROP_WIDTH, 2);
   }
   else
   {
      ObjectMove("MidPoint", 0, Time[0], MidPoint);
   }
}


void Write(string String)
{
   int Handle;

   if (!Auditing) return;

   Handle = FileOpen(Filename, FILE_READ|FILE_WRITE|FILE_CSV, "/t");
   if (Handle < 1)
   {
      Print("Error opening audit file: Code ", GetLastError());
      return;
   }

   if (!FileSeek(Handle, 0, SEEK_END))
   {
      Print("Error seeking end of audit file: Code ", GetLastError());
      return;
   }

   if (FileWrite(Handle, TimeToStr(CurTime(), TIME_DATE|TIME_SECONDS) + "  " + String) < 1)
   {
      Print("Error writing to audit file: Code ", GetLastError());
      return;
   }

   FileClose(Handle);
}

void CloseAllOrders()
{
bo=0;so=0;
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	   if (OrderSymbol()==Symbol()&& OrderMagicNumber()==Reference) 
      {
         if (OrderType()==OP_BUY  ) { bo++;}
        // if (buysell<-2000){ OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow); }
                 if (teudiff<-100000){ OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow); }

          
         if (OrderType()==OP_SELL ) { so++;}
         //if (buysell<-2000 ){OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Yellow); }
                  if (teudiff>100000){OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Yellow); }

         
        
      }
   }
}